package com.bernhardriedl.projects.tools.utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;
import java.util.Random;

public class Utils {

	static private Random r=new Random();

	/**
	 * Get the extension of a file.
	 * @param f File
	 * @return Extension
	 */

	public static String getExtension(File f) {
		String ext = null;
		String s = f.getName();

		int i = s.lastIndexOf('.');

		if (i > 0 && i < s.length() - 1)
			ext = s.substring(i + 1).toLowerCase();

		return ext;
	}

	/**
	 * rounds a double
	 * with two positions after the comma
	 * @param input double
	 * @return rounded double
	 */

	static public double rundeDouble (double input) {
		double format = Math.round(input * 100.0);
		return format / 100.0;
	}

	/**
	 * getLimitedRandom
	 * @param random int
	 * @param max int
	 * @return int
	 */

	static public int getLimitedRandom(int max) {
		int random=Utils.r.nextInt();

		return (Math.abs(random))%(max+1);
	}

	/**
	 * copyFile
	 * taken from http://www.rgagnon.com/javadetails/java-0064.html
	 * @param in source-file
	 * @param out destination-file
	 * @throws IOException
	 */

	public static void copyFile(File in, File out) throws IOException {
		FileChannel inChannel = new FileInputStream(in).getChannel();
		FileChannel outChannel = new FileOutputStream(out).getChannel();

		try {

			/**
			 * magic number for Windows, 64Mb - 32Kb)
			 * http://forums.sun.com/thread.jspa?threadID=439695&messageID=2917510
			 */

			int maxCount = (64 * 1024 * 1024) - (32 * 1024);

			long size = inChannel.size();
			long position = 0;

			while (position < size)
				position += inChannel.transferTo(position, maxCount, outChannel);
		}

		catch (IOException e) {
			throw e;
		}

		finally {
			if (inChannel != null) inChannel.close();
			if (outChannel != null) outChannel.close();
		}
	}
}