package com.bernhardriedl.projects.tools.utils;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.Vector;

public class WriteFile {

	private String fileName=null;
	private BufferedWriter ostream=null;
	private FileOutputStream ost=null;

	/**
	 * Constructor
	 * @param fileName String
	 */

	public WriteFile(String fileName) {
		this.setFileName(fileName);
	}
	
	/**
	 * setter FileName
	 * @param fileName String
	 */

	public void setFileName(String fileName) {
		this.fileName=fileName;
	}

	/**
	 * getter FileName
	 * @return String
	 */

	public String getFileName() {
		return this.fileName;
	}

	/**
	 * open Textfile
	 * @throws FileNotFoundException
	 */
	
	public void open() throws FileNotFoundException {
		File textFile=new File(this.fileName);
		this.ost = new FileOutputStream(textFile);
		this.ostream = new BufferedWriter(new OutputStreamWriter(ost));
	}

	/**
	 * write
	 * @param line String
	 * @throws IOException
	 */

	public void writeLine(String line) throws IOException {
		if (line!=null) {
			this.ostream.write(line);
			this.ostream.flush();
		}
	}

	/**
	 * writes Vector to file
	 * overwrites file
	 * @param newLines Vector
	 * @throws IOException 
	 */

	public void overwriteFile(Vector <String> newLines) throws IOException {

		/**
		 * write lines to file
		 */

		for (int i=0;i<newLines.size();i++) {
			this.writeLine(newLines.elementAt(i).toString());
			this.ostream.newLine();
		}
	}

	/**
	 * close Textfile
	 * @throws IOException
	 */

	public void close() throws IOException {
		this.ostream.close();
		this.ost.close();
	}
}